require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe StallsController do

  # This should return the minimal set of attributes required to create a valid
  # Stall. As you add validations to Stall, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all stalls as @stalls" do
      stall = Stall.create! valid_attributes
      get :index
      assigns(:stalls).should eq([stall])
    end
  end

  describe "GET show" do
    it "assigns the requested stall as @stall" do
      stall = Stall.create! valid_attributes
      get :show, :id => stall.id.to_s
      assigns(:stall).should eq(stall)
    end
  end

  describe "GET new" do
    it "assigns a new stall as @stall" do
      get :new
      assigns(:stall).should be_a_new(Stall)
    end
  end

  describe "GET edit" do
    it "assigns the requested stall as @stall" do
      stall = Stall.create! valid_attributes
      get :edit, :id => stall.id.to_s
      assigns(:stall).should eq(stall)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new Stall" do
        expect {
          post :create, :stall => valid_attributes
        }.to change(Stall, :count).by(1)
      end

      it "assigns a newly created stall as @stall" do
        post :create, :stall => valid_attributes
        assigns(:stall).should be_a(Stall)
        assigns(:stall).should be_persisted
      end

      it "redirects to the created stall" do
        post :create, :stall => valid_attributes
        response.should redirect_to(Stall.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved stall as @stall" do
        # Trigger the behavior that occurs when invalid params are submitted
        Stall.any_instance.stub(:save).and_return(false)
        post :create, :stall => {}
        assigns(:stall).should be_a_new(Stall)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        Stall.any_instance.stub(:save).and_return(false)
        post :create, :stall => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested stall" do
        stall = Stall.create! valid_attributes
        # Assuming there are no other stalls in the database, this
        # specifies that the Stall created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        Stall.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => stall.id, :stall => {'these' => 'params'}
      end

      it "assigns the requested stall as @stall" do
        stall = Stall.create! valid_attributes
        put :update, :id => stall.id, :stall => valid_attributes
        assigns(:stall).should eq(stall)
      end

      it "redirects to the stall" do
        stall = Stall.create! valid_attributes
        put :update, :id => stall.id, :stall => valid_attributes
        response.should redirect_to(stall)
      end
    end

    describe "with invalid params" do
      it "assigns the stall as @stall" do
        stall = Stall.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Stall.any_instance.stub(:save).and_return(false)
        put :update, :id => stall.id.to_s, :stall => {}
        assigns(:stall).should eq(stall)
      end

      it "re-renders the 'edit' template" do
        stall = Stall.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Stall.any_instance.stub(:save).and_return(false)
        put :update, :id => stall.id.to_s, :stall => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested stall" do
      stall = Stall.create! valid_attributes
      expect {
        delete :destroy, :id => stall.id.to_s
      }.to change(Stall, :count).by(-1)
    end

    it "redirects to the stalls list" do
      stall = Stall.create! valid_attributes
      delete :destroy, :id => stall.id.to_s
      response.should redirect_to(stalls_url)
    end
  end

end
